package JavaCode;

/*
SLIDER: Local Short Reads DNA Sequence Alignment
Beta Release; Ver 0.1, 22th Mar. 2008
By: Nawar Malhis
Canada's Michael Smith Genome Sciences Centre
*/

public class Oligo implements Comparable<Oligo> {
    static final int now = 2;
	static final int A = 0;          // 
	static final int C = 1;          // 
	static final int G = 2;          // 
	static final int T = 3;          // 
	// static       int[] shft = {0, 0};
	
	static final int MAXU = 111;
	// static final int MAXCH = 100;
	
	static final byte FPT = 0x01;
	static final byte FS0 = 0x02;
	static final byte FMP = 0x04;
	static final byte FU0 = 0x08;
	static final byte FRC = 0x10;
	static final byte FUQ = 0x20;
	static final byte FUM = 0x40;
	static final byte FJM = -128; // 0x80

	static final int SEQ    = 0;
	static final int ID     = 1;
	static final int WEIGHT = 2;
	static final int LOCATION = 3;
	
    // public static int nou = 2;
    public static boolean bac = true;
    public static final int wordSize = 31;
    static final char[] nucl  = {'A', 'C', 'G', 'T', 'N'}; // used to convert int to char
    
	private static final long mask[] = {
		0x0000000000000003L, 0x000000000000000CL, 0x0000000000000030L, 0x00000000000000C0L,
		0x0000000000000300L, 0x0000000000000C00L, 0x0000000000003000L, 0x000000000000C000L,
		0x0000000000030000L, 0x00000000000C0000L, 0x0000000000300000L, 0x0000000000C00000L,
		0x0000000003000000L, 0x000000000C000000L, 0x0000000030000000L, 0x00000000C0000000L,
		0x0000000300000000L, 0x0000000C00000000L, 0x0000003000000000L, 0x000000C000000000L,
		0x0000030000000000L, 0x00000C0000000000L, 0x0000300000000000L, 0x0000C00000000000L,
		0x0003000000000000L, 0x000C000000000000L, 0x0030000000000000L, 0x00C0000000000000L,
		0x0300000000000000L, 0x0C00000000000000L, 0x3000000000000000L
		};
	
	public static final long fullMask[] = { 0x0000000000000000L,
		0x3000000000000000L, 0x3300000000000000L, 0x3F00000000000000L, 0x3F30000000000000L, 
		0x3FF0000000000000L, 0x3FF3000000000000L, 0x3FFF000000000000L, 0x3FFF300000000000L, 
		0x3FFFF00000000000L, 0x3FFFF30000000000L, 0x3FFFFF0000000000L, 0x3FFFFF3000000000L, 
		0x3FFFFFF000000000L, 0x3FFFFFF300000000L, 0x3FFFFFFF00000000L, 0x3FFFFFFF30000000L, 
		0x3FFFFFFFF0000000L, 0x3FFFFFFFF3000000L, 0x3FFFFFFFFF000000L, 0x3FFFFFFFFF300000L, 
		0x3FFFFFFFFFF00000L, 0x3FFFFFFFFFF30000L, 0x3FFFFFFFFFFF0000L, 0x3FFFFFFFFFFF3000L, 
		0x3FFFFFFFFFFFF000L, 0x3FFFFFFFFFFFF300L, 0x3FFFFFFFFFFFFF00L, 0x3FFFFFFFFFFFFF30L, 
		0x3FFFFFFFFFFFFFF0L, 0x3FFFFFFFFFFFFFF3L, 0x3FFFFFFFFFFFFFFFL 
		};

	public static  char[] str;

    public static long compMask[] = {0x3FFFFFFFFFFFFFFFL, 0x3FFFFFFFFFFFFFFFL};
    
    public static long code[][];
    
    public static int sortIndex = 0;
    public static long dTmp[] = {0, 0};
    public static int numberOfBACs;
    public static String[] BACs;
    // public static String[] BACF;
    public static int  sfi;
    public static int  sfw;
    public static int  sri;
    public static int  srw;
    
    public long[] d;
    public float  weight;
    public int    start;
    public byte   ch;
    public int    size;
    public int    id1;
    public byte   flg;
    // public byte   nsq;
    public byte   u0;
    // public byte   snp;

    public int compareTo(Oligo o){
 	   if (sortIndex == SEQ) {
 		   int[] x = new int[2];
 		   int sz = size;
 		   if (sz > wordSize) {
 	 		   x[0] = 31;
 	 		   x[1] = ((sz - 1) % wordSize) + 1;
 	 		   if ((o.d[0] & compMask[0] & fullMask[x[0]]) == (this.d[0] & compMask[0] & fullMask[x[0]])) {
	 	 			 if ((o.d[1] & compMask[1] & fullMask[x[1]]) > (this.d[1] & compMask[1] & fullMask[x[1]])) {
		  	 	 	 		return -1;
		  	 	 	 	} else if ((o.d[1] & compMask[1] & fullMask[x[1]]) < (this.d[1] & compMask[1] & fullMask[x[1]])) {
	 	 	 	 			   return 1;
		 	 	 		   } else {
	 	 	 	 			   return 0;
		 	 	 		   }	 		   
 	 		   } else if ((o.d[0] & compMask[0] & fullMask[x[0]]) > (this.d[0] & compMask[0] & fullMask[x[0]])) {
 	 			   return -1;
 	 		   } else {
 	 			   return 1;
 	 		   }
 		   } else {
 			  x[0] = sz;
 			 if ((o.d[0] & compMask[0] & fullMask[x[0]]) == (this.d[0] & compMask[0] & fullMask[x[0]])) {
 				 return 0;
 			 } else if ((o.d[0] & compMask[0] & fullMask[x[0]]) > (this.d[0] & compMask[0] & fullMask[x[0]])) {
	 			   return -1;
	 		   } else {
	 			   return 1;
	 		   }
 		   }
 	   } else if (sortIndex == ID) {
 		   if (o.id1 == id1) {
 			   if (o.getSide() == getSide()) {
 	 			   if (o.weight == weight) {
 	 				   return 0;
 	 			   } else if (o.weight > weight) {
 	 				   return 1;
 	 			   } else {
 	 				   return -1;
 	 			   }
 			   } if (isSide0()) {
 				   return -1;
 			   } else {
 				   return 1;
 			   }
 		   } else if (o.id1 < id1) {
 			   return -1;
 		   } else {
 			   return 1;
 		   }
 	   } else if (sortIndex == WEIGHT) {
 		   if (o.weight > weight) {
 			   return 1;
 		   } else if (o.weight < weight) {
 			   return -1;
 		   } else {
 			   return 0;
 		   }
 	   } else if (sortIndex == LOCATION) {
 		   if (o.ch == ch) {
 	 		   if (o.start > start) {
 	 			   return -1;
 	 		   } else if (o.start < start) {
 	 			   return 1;
 	 		   } else {
 	 			   return 0;
 	 		   }
 	 	   } else if (o.ch > ch) {
 	 		   return -1;
 	 	   } else {
 	 		   return 1;
 	 	   }
 	   }
 	   return 0;	   
    }

   public Oligo() throws Exception {
	   d = new long[now];
	   // u = new byte[nou]; 
	   weight = (float) 1.0;
	   size   = 62;
	   id1    = 0;
	   flg    = 0;
	   // snp    = -1;
	   for (int i = 0; i < now; i++) {
		   d[i] = 0;
	   }
	   
	   u0 = -1;
	  
   }
   public Oligo(String s) throws Exception {
	   d = new long[now];
	   u0 = -1; 
	   weight = (float) 1.0;
	   id1     = 0;
	   flg     = 0;
	   // snp     = -1;
	   size   = s.length();
	   int x  = size % wordSize;;
	   int nw = size / wordSize;
	   for (int i = 0; i < nw; i++) {
		   for (int j = 0; j < wordSize; j++) {
			   // System.err.print(s.charAt(i* wordSize + j) + "\t" + getBpInt(s.charAt(i* wordSize + j)));
			   d[i] = d[i] | code [getBpInt(s.charAt(i* wordSize + j))][wordSize - j - 1];
		   }
	   }
	   for (int j = 0; j < x; j++) {
		   d[nw] = d[nw] | code [getBpInt(s.charAt(nw * wordSize + j))][wordSize - j - 1];
	   }

   }
   public Oligo(Oligo oligo) {
	   d = new long[now];
	   u0 = oligo.u0; 
	   for (int i = 0; i < now; i++) {
		   d[i] = oligo.d[i];
	   }
	   weight = oligo.weight;
	   start  = oligo.start;
	   ch     = oligo.ch;
	   size   = oligo.size;
	   id1    = oligo.id1;
	   flg    = oligo.flg;
	   // snp    = oligo.snp;
   }
//*
   public float getMappingScore(byte uF0, byte uR0, float w) throws Exception{
	   /*
	   float s;
	   float tmp = 0;
	   int extra = 0;
	   if (!isU0()) {
		   extra += Parameters.extra0;
	   } 
	   if(isRC()) {
		   tmp = size - uR0 - extra + 1;
	   } else {
		   tmp = size - uF0 - extra + 1;
	   }
	   if (tmp < 1) {
		   tmp = 1;
	   }
	   s = ((float) Math.log(tmp) / (float) 2.3025851);
	   //*/
	   return w;// + w;
   }
   
   // Oligo[] o: <input> is an array of possible Oligos that are generated from one prb line
   // int ix: <output> the index of the best patch, (ix = -1) if no good match
   // int[] cvrg: <output> is an array of oligoSize, coverage for the best match
   public float equalPET(Oligo[] o, int ix, int[] cvrg) {
	   float matchScore = 0; // range [0..1]
	   
	   
	   return matchScore;
   }
   
   public int equal(Oligo o, int sz) {
	   int[] x = new int[2];
	   if (sz > wordSize) {
		   x[0] = 31;
		   x[1] = ((sz - 1) % wordSize) + 1;
 		   // x[1] = sz % wordSize + 1;
 		   if ((o.d[0] & fullMask[x[0]]) == (this.d[0] & fullMask[x[0]])) {
 			   long l0 = (o.d[1] & fullMask[x[1]]);
 			   long l1 = (this.d[1] & fullMask[x[1]]);
 			   if ((o.d[1] & fullMask[x[1]]) > (this.d[1] & fullMask[x[1]])) {
 				   return 10;
 			   } else if (l0 < l1) {
 				   return -10;
 			   } else {
 				   return 0;
 			   }	 		   
 		   } else if ((o.d[0] & fullMask[x[0]]) > (this.d[0] & fullMask[x[0]])) {
 			   return 10;
 		   } else {
 			   return -10;
 		   }
	   } else {
		   x[0] = sz;
		   if ((o.d[0] & fullMask[x[0]]) == (this.d[0] & fullMask[x[0]])) {
			   return 0;
		   } else if ((o.d[0] & fullMask[x[0]]) > (this.d[0] & fullMask[x[0]])) {
			   return 10;
 		   } else {
 			   return -10;
 		   }
	   }
   }
   //*/
   public byte matchR(Oligo o) {
	   byte l = MAXU;
	   int i;
	   /*
	   if (isRC())
		   revers();
	   if (o.isRC())
		   o.revers();
	   //*/
	   for (i = 0; i < now; i++) {
		   if ((o.d[i] & compMask[i]) != (this.d[i] & compMask[i]))
			   break;
	   }
	   if (i == now) {
		   /*
		   if (isRC())
			   revers();
		   if (o.isRC())
			   o.revers();
		   //*/
		   return MAXU;
	   }
	   l = matchOne(d[i], o.d[i], i);
	   if (l < 100)
		   l += (i * 31);
	   /*
	   if (isRC())
		   revers();
	   if (o.isRC())
		   o.revers();
	   //*/
	   return l;
   }
   public byte match(Oligo o) {
	   byte l = MAXU;
	   int i;
	   
	   for (i = 0; i < now; i++) {
		   if ((o.d[i] & compMask[i]) != (this.d[i] & compMask[i]))
			   break;
	   }
	   
	   if (i == now)
		   return MAXU;
	   
	   l = matchOne(d[i], o.d[i], i);
	   
	   if (l < 100)
		   l += (i * 31);
	   
	   return l;
   }
   private byte matchOne(long l1, long l2, int j) {
	   byte i;
	   for (i = 30; i >= 0; i--) {
		   if ((((l1 ^ l2) & mask[i]) & compMask[j]) != 0) 
			   return (byte) (30 - i);
	   }
	   return MAXU;
   }

   public static void setMask(int x) {
	   int w = x / wordSize;
	   int i = x % wordSize;
	   compMask[w] = compMask[w] & ~mask[i];
   }
   public static void clearMask() {
	   for (int i = 0; i < now; i++) {
		   compMask[i] = 0x3FFFFFFFFFFFFFFFL;
	   }	   
   }

   public void comp() throws Exception {
	   int x  = size % wordSize;
	   int nw = size / wordSize;
	   if (nw > 2) {
		   System.err.println("\n --------------- size:\t" + size);
	   } else {
		   setRC(true);
		   for (int i = 0; i < nw; i++) {
			   d[i] = (~d[i]) & 0x3FFFFFFFFFFFFFFFL;
		   }
		   if (x > 0)
			   d[nw] = (~d[nw]) & fullMask[x];
	   }
   }

   public void reversComp() throws Exception {
	   comp();
	   revers();
   }
   public void revers() {
	   int fi;
	   int ri;
	   // System.err.println(this + "\tsize: " + size);
	   for (fi = 0; fi < size/2; fi++) {
		   ri = size - fi - 1;
		   swap(fi, ri);
		   // System.err.println(this + "\t" + fi + "\t" + ri);
	   }
   }

   private void swap(int fi, int ri) {
	   long tmpf;
	   long tmpr;
	   getIdx(fi, ri);
	   // System.err.println("\tsfi: " + sfi + "\tsfw: " + sfw + "\tsri: " + sri + "\tsrw: " + srw);
	   tmpf = d[sfw] & mask[sfi];
	   tmpr = d[srw] & mask[sri];
	   d[sfw] = d[sfw] & ~mask[sfi];
	   d[srw] = d[srw] & ~mask[sri];
	   if (sfi < sri) {
		   tmpf = tmpf <<  (2 * (sri - sfi));
		   tmpr = tmpr >>> (2 * (sri - sfi));		   
	   } else if (sfi > sri) {
		   tmpf = tmpf >>> (2 * (sfi - sri));
		   tmpr = tmpr <<  (2 * (sfi - sri));
	   } 
	   d[sfw] = d[sfw] | tmpr;
	   d[srw] = d[srw] | tmpf;	   
   }
   
   private void getIdx(int fi, int ri) {
	   // int nw = (size - 1) / wordSize;
	   // int st1 = size % wordSize;
	   // shft[0] = 0;
	   // shft[nw] = wordSize - st1;
	   // shft[nw] = shft[nw] % wordSize;
	   
	   sfw = fi / wordSize;
	   sfi = wordSize - (fi % wordSize ) - 1; // + shft[sfw];
	   srw = ri / wordSize;
	   sri = wordSize - (ri % wordSize ) - 1; // + shft[srw];
	   // System.err.println("fi: " + fi + ",\tsfw: " + sfw + ",\tri: " + ri + "\tsrw: " + srw + "\tshft: " + shft[nw] + "\tst1: " + st1);
   }
 
   public static int  getBpInt(char b) {
    	if (b == 'A')
    	    return A;
    	if (b == 'C')
    	    return C;
    	if (b == 'G')
    	    return G;
    	if (b == 'T')
    	    return T;
    	return -1;
        }

   private void deCodeIt() {
	   long a;
	   int sz = Oligo.now * wordSize + 1;
	   str = new char[sz];
	   for (int w = 0; w < now; w++) {
		   for (int i = 0; i < wordSize; i++) {
			   a = d[w];
			   a = a << (2 + 2 * i);
			   a = a >>> (62);
			   str[w * wordSize + i] = nucl[(int) a];
		   }
	   }
   }
   
   public char getBPat(int x) {
	   char bp;
	   int w = x / wordSize;
	   int i;
	   long a;
	   if (w > 0) {
		   i = x % w;
	   } else {
		   i = x;
	   }
	   a = d[w];
	   a = a << (2 + 2 * i);
	   a = a >>> (62);
	   bp = nucl[(int) a];	   
	   return bp;
   }

   public boolean isUQ() {
	   if ((FUQ & flg) == 0) 
		   return false;
	   else
		   return true;
   }
   public void setUQ(boolean uq) {
	   if (uq) {
		   flg = (byte) (flg | FUQ);
	   } else {
		   flg = (byte) (flg & ~FUQ);		   
	   }
   }
  
   public boolean isUM() {
	   if ((FUM & flg) == 0) 
		   return false;
	   else
		   return true;
   }
   public void setUM(boolean um) {
	   if (um) {
		   flg = (byte) (flg | FUM);
	   } else {
		   flg = (byte) (flg & ~FUM);		   
	   }
   }
 
   public boolean isPET() {
	   if ((FPT & flg) == 0) 
		   return false;
	   else
		   return true;
   }
   public void setPET(boolean pt) {
	   if (pt) {
		   flg = (byte) (flg | FPT);
	   } else {
		   flg = (byte) (flg & ~FPT);		   
	   }
   }
   
   public boolean isU0() {
	   if ((FU0 & flg) == 0) 
		   return false;
	   else
		   return true;
   }
   public void setU0(boolean u0) {
	   if (u0) {
		   flg = (byte) (flg | FU0);
	   } else {
		   flg = (byte) (flg & ~FU0);		   
	   }
   }
   
   public int getSide() {
	   if ((FS0 & flg) == 0) 
		   return 1;
	   else
		   return 0;
   }
   public boolean isSide0() {
	   if ((FS0 & flg) == 0) 
		   return false;
	   else
		   return true;
   }
   public void setSide(int s) {
	   // System.err.print("setUM\t" + um + "\t" + flg);
	   if (s == 0) {
		   flg = (byte) (flg | FS0);
	   } else {
		   flg = (byte) (flg & ~FS0);		   
	   }
	   // System.err.println("\t" + flg);
   }
   
   public boolean isLQ() { // FMP
	   if ((FJM & flg) == 0) 
		   return false;
	   else
		   return true;
   }
   public void setLQ(boolean jm) {
	   // System.err.print("setUM\t" + um + "\t" + flg);
	   if (jm) {
		   flg = (byte) (flg | FJM);
	   } else {
		   flg = (byte) (flg & ~FJM);		   
	   }
	   // System.err.println("\t" + flg);
   }
   
   public boolean isMP() { // FMP
	   if ((FMP & flg) == 0) 
		   return false;
	   else
		   return true;
   }
   public void setMP(boolean mp) {
	   // System.err.print("setUM\t" + um + "\t" + flg);
	   if (mp) {
		   flg = (byte) (flg | FMP);
	   } else {
		   flg = (byte) (flg & ~FMP);		   
	   }
	   // System.err.println("\t" + flg);
   }   

   public boolean isRC() { // FMP
	   if ((FRC & flg) == 0) 
		   return false;
	   else
		   return true;
   }
   public void setRC(boolean rc) {
	   // System.err.print("setUM\t" + um + "\t" + flg);
	   if (rc) {
		   flg = (byte) (flg | FRC);
	   } else {
		   flg = (byte) (flg & ~FRC);		   
	   }
	   // System.err.println("\t" + flg);
   }
   
   public String toString() {
	   
	   deCodeIt();
	   String tmp;
	   String s;
	   String sq;
	   int sEnd;
	   char rn;

	   if (isRC()) {
		   rn = 'R';
	   } else {
		   rn = 'F';
	   }
	   if(numberOfBACs > 0) {
		   sq = BACs[ch];
	   } else {
		   sq = Parameters.SEQ_VAR[ch];
	   }
	   s =  sq + "\t" + start + "\t" + rn + "\t" + weight + "\t" + size + "\t" + id1 + "\t";
	   if (isUQ())
		   s += "UQ\t";
	   else 
		   s += "UD\t";

	   if (isMP())
		   s += "MP\t";
	   else 
		   s += "RS\t";

	   if (isLQ())
		   s += "JM\t";
	   else 
		   s += "GR\t";

	   if (isUM())
		   s += "UM\t";
	   else 
		   s += "MM\t";

	   if (isSide0())
		   s += "S0\t";
	   else 
		   s += "S1\t";

	   if (isPET())
		   s += "PET\t";
	   else 
		   s += "SET\t";

	   if (isU0())
		   s += "U0";
	   else 
		   s += "U1";

	   s += "\t" + u0;

	   s += "\t";
	   
	   tmp = (new String(str)).substring(0, size);
	   for (int i = 0; i < size;) {
		   if ((i + 10) >= size) {
			   sEnd = size;
		   } else {
			   sEnd = i + 10;
		   }
		   s += " " + tmp.substring(i, sEnd);
		   i += 10;
	   }
	   s += "\t";
	   return s;
   }

   public String toSeq() {
	   deCodeIt();
	   String sq = (new String(str)).substring(0, size);
	   return sq;
   }
}
